(require [kodhy.macros [lc afind rmap amap ordf filt ecase λ qw getl geti $ geta wc ss cbind replicate]])

(import
  os
  sys
  hashlib
  random 
  [regex :as rx]
  [collections [OrderedDict]]
  [numpy :as np]
  [scipy.special [expit]]
  [scipy.stats :as scist]
  [pandas :as pd]
  [sklearn.linear-model :as sklm]
  [seaborn :as sns]
  [matplotlib.pyplot :as plt]
  [kodhy.util [T F rd seq cached-eval valcounts
    pretty-json-to-pd kfold-cv-pred hzscore ucfirst
    pairs pds-from-pairs]])

(setv obs (pretty-json-to-pd "../data.json"))
; Only analyze observations through September 2017.
(setv obs (.reset-index :drop T (ss obs (< $interviewed "2017-10"))))

(setv ($ obs interviewed) (pd.to-datetime ($ obs interviewed)))
(setv ($ obs risky_sex_transmit_d) ($ obs risky_sex_transmit))
(setv (getl obs (= ($ obs hiv_load_detect) "Undetectable") "risky_sex_transmit_d")
  "Safe")

(setv obs1 (.apply (.groupby obs "s") (λ (geti it 0))))

(defmacro cache [key expr &optional [bypass 'None]]
  `(cached-eval ~key (fn [] ~expr) ~bypass (os.path.join (os.path.expanduser "~")
     ".daylight" "py-cache" "Kodi-projects" "mstudy")))

(setv s-hiv-status-changed (lc [[s x] (.groupby obs "s")]
  (> (len (.unique ($ x hiv_status))) 1)
  s))
(setv s-good (sorted (.difference (set ($ obs s))
  s-hiv-status-changed)))

(setv obs-hiv- (ss obs (&
  (= $hiv_status "HIV-")
  (~ (.isin $s s-hiv-status-changed)))))
(setv obs-hiv+ (ss obs (&
  (= $hiv_status "HIV+")
  (~ (.isin $s s-hiv-status-changed)))))
